input[type="checkbox"],
input[type="radio"] {
    --wrapper-size: 40px;
    --size: 18px;
    --state-color: var(--action);
    --on-state-color: var(--on-action);
    --unchecked-border-color: var(--outline);

    appearance: none;
    display: block flex;
    align-items: center;
    justify-content: center;
    width: var(--wrapper-size);
    height: var(--wrapper-size);
    border-radius: var(--r-circular);
    position: relative;
    transition: var(--all-ease-short);
    cursor: pointer;
    margin: 0;

    @media (pointer:fine) {
        &:hover {
            background-color: var(--c-ink-hover);
        }
    }

    &:focus-visible {
        outline: 2px solid var(--action);
    }

    &:active {
        background-color: var(--c-ink-active);
    }

    &:user-invalid {
        --state-color: var(--c-error);
        --unchecked-border-color: var(--c-error);
    }

    &:disabled {
        opacity: 0.5;
    }

    &::before {
        content: " ";
        position: absolute;
        z-index: 1;
        border-radius: 4px;
        border: 2.5px solid var(--unchecked-border-color);
        width: var(--size);
        height: var(--size);
        transition: var(--all-ease-short);
    }

    &[type="radio"]::before {
        border-radius: var(--r-circular);
    }

    &:checked::before,
    &[type="checkbox"]:indeterminate::before {
        background-color: var(--state-color);
        border-color: var(--state-color);
    }

    &::after {
        content: " ";
        position: absolute;
        z-index: 2;
        width: 0;
        height: 0;
        opacity: 0;
        transition: var(--all-ease-short);
    }

    &[type="checkbox"]::after {
        border-right: 2px solid var(--on-state-color);
        border-bottom: 2px solid var(--on-state-color);
    }

    &[type="radio"]::after {
        border-radius: var(--r-circular);
        border: 3px solid var(--on-state-color);
    }

    &:checked::after,
    &[type="checkbox"]:indeterminate::after {
        opacity: 1;
    }

    &[type="radio"]:checked::after {
        width: calc(var(--size) - 6px);
        height: calc(var(--size) - 6px);
    }


    &[type="checkbox"]:checked:not(:indeterminate)::after {
        width: calc(var(--size) / 3);
        height: calc(var(--size) / 1.5);
        rotate: 45deg;
        translate: 0 -15%;
    }

    &[type="checkbox"]:indeterminate::after {
        width: 0;
        height: calc(var(--size) / 1.5);
        rotate: 90deg;
        translate: none;
    }
}

.input-box {
    --padding-top: 12px;
    --input-height: 44px;
    --input-padding: 0 16px;
    --state-color: var(--on-surface-soft);
    --unchecked-border-color: var(--outline);
    --c-label-bg: var(--white);

    display: block flex;
    flex-direction: column;
    justify-content: flex-start;
    align-items: stretch;
    gap: 4px;
    position: relative;
    width: 100%;
    padding: var(--padding-top) 0 0 0;

    input,
    textarea {
        color: var(--c-on-surface);
        font: inherit;
        width: 100%;
        border-radius: 8px;
        border: 1px solid var(--unchecked-border-color);
        background: transparent;
        transition: var(--all-ease-short);
        font-size: 1em;
    }

    input {
        padding: 0 15px;
        height: var(--input-height);
    }

    textarea {
        padding: 12px 15px;
        min-height: calc(var(--input-height) * 2);
        resize: vertical;
        padding-top: 24px;
    }

    textarea::-webkit-resizer {
        background-color: transparent;
    }

    input:-webkit-autofill,
    input:-webkit-autofill:hover,
    input:-webkit-autofill:focus,
    input:-webkit-autofill:active {
        -webkit-box-shadow: 0 0 0 var(--input-height) var(--c-label-bg) inset !important;
        color: var(--c-on-surface) !important;
    }

    &:has(input:focus),
    &:has(textarea:focus) {
        --state-color: var(--action);
    }

    &:has(input:disabled),
    &:has(textarea:disabled) {
        opacity: 0.5;
    }

    &:has(input:user-invalid),
    &:has(textarea:user-invalid) {
        --state-color: var(--c-error);
        --unchecked-border-color: var(--c-error);
    }

    input:focus,
    textarea:focus {
        border: 2px solid var(--state-color);
        outline: none;
    }

    label {
        position: absolute;
        pointer-events: none;
        translate: 0 -50%;
        padding: 0 4px;
        left: 12px;
        top: calc(calc(var(--padding-top) + 100%) / 2);
        transform-origin: left center;
        transition: var(--all-ease-medium);
        color: var(--state-color);
        background-color: var(--c-label-bg);
    }

    input:required~label::after,
    textarea:required~label::after {
        content: " *";
    }

    &:has(textarea) label {
        padding: 0 4px;
        top: calc(var(--padding-top) * 3);
    }

    .hint {
        padding: 0 16px;
        overflow: hidden;
        font-size: 0.75em;
        color: var(--on-surface-soft)
    }

    .hint:empty {
        display: none;
        max-height: 0;
    }

    input[maxlength]~.hint::after,
    textarea[maxlength]~.hint::after {
        content: attr(count);
        display: inline;
        float: right;
        padding-left: 16px;
    }

    input:user-invalid~.hint,
    textarea:user-invalid~.hint {
        color: var(--c-error);
    }

    input:focus+label,
    input:not(:placeholder-shown)+label,
    textarea:focus+label,
    textarea:not(:placeholder-shown)+label {
        top: 12px;
        scale: 0.75;
    }

    input:focus {
        padding: 0 14px;
    }

    textarea:focus {
        padding: 12px 14px;
    }
}